function dataURLtoFile(dataurl, filename) {
    var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
        bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
    while(n--){
        u8arr[n] = bstr.charCodeAt(n);
    }
    return new File([u8arr], filename, {type:mime});
}
function imageProcess() {
    //监听图片源表单的改变事件
	var oldimg=$("#upPhotos")[0].files[0];
                var reader = new FileReader();
                reader.onload = function(e){
                    var imageSize = e.total;//图片大小
                    var image = new Image();
                    image.src = e.target.result;
                    image.onload = function () {
                        // 处理图片
                       rotateImage(image);
                    }
                }
                reader.readAsDataURL(oldimg);
}

/**
 * 旋转压缩图片
 * @param image         HTMLImageElement
 * @returns newImage    HTMLImageElement
 */
function rotateImage(image) {
    console.log('rotateImage');
    var width = image.width;
    var height = image.height;

    var canvas = document.createElement("canvas")
    var ctx = canvas.getContext('2d');
    //旋转图片操作
    EXIF.getData(image,function () {
            var orientation = EXIF.getTag(this,'Orientation');
            // orientation = 6;//测试数据
            console.log('orientation:'+orientation);
            switch (orientation){
                //正常状态
                case 1:
                    console.log('旋转0°');
                    canvas.height = height;
                    canvas.width = width;
										ctx.drawImage(image, 0, 0);

                    break;
                //旋转90度
                case 6:
                    console.log('旋转90°');
                    canvas.height = width;
                    canvas.width = height;
                    ctx.rotate(Math.PI/2);
                    ctx.translate(0,-height);
										ctx.drawImage(image, 0, 0);

                    break;
                //旋转180°
                case 3:
                    console.log('旋转180°');
                    canvas.height = height;
                    canvas.width = width;
                    ctx.rotate(Math.PI);
                    ctx.translate(-width,-height);
										ctx.drawImage(image, 0, 0);

                    break;
                //旋转270°
                case 8:
                    console.log('旋转270°');
                    canvas.height = width;
                    canvas.width = height;
                    ctx.rotate(-Math.PI/2);
                    ctx.translate(-height,0);
	                 	ctx.drawImage(image, 0, 0);
                    break;
                //undefined时不旋转
                case undefined:
                    console.log('undefined  不旋转');
										canvas.height = height;
										canvas.width = width;
										ctx.drawImage(image, 0, 0);

                    break;
            }
	
			imageDate = canvas.toDataURL('Image/jpeg',0.1);
			var blob = dataURLtoFile(imageDate,"abc.jpg");
				var formData = new FormData();
				formData.append("file", blob);
				$.ajax({
					url: getUrl("22") + getUser().userId,
					type: "POST",
					data: formData,
					contentType: false,
					processData: false,
					success: function(data) {
						if (data.message == "ok") {
							$("#myinfo").find("img").attr("src", data.data.headIcon)
							setCache("userInfo", data.data);
							checkLogin();
						}
						ptoast(data.message);
					}
				})
        }
    );
}

